;*** Versuch3/Autor:U.Zschuckelt Datum:23.12.91 ***
;*** CodeX-Assembler                            ***

;-----------------------
; Offsets !!!!!
;-----------------------

openscreen:    equ -$c6           ;intuition Funktionen
closescreen:   equ -$42
openwindow:    equ -$cc
closewindow:   equ -$48
printitext:    equ -$d8

spmul:         equ -$4e           :mathffp Funktionen
spdiv:         equ -$54
spfix:         equ -$1e
spflt:         equ -$24
spsub:         equ -$48

;-----------------------
; Hauptprogramm
;-----------------------

 bsr openlibs                     ;Libraries ffnen
 beq abbruch                      ;Fehler ->Abbruch

;*** Screen ffnen ***

 move.l intuitionbase(pc),a6      ;Vector base holen
 lea screen,a0                    ;Struktur holen
 jsr openscreen(a6)               ;Screen ffnen
 move.l d0,screenpointer          ;Pointer retten
 beq abbruch1                     ;Fehler -> Abbruch1

;*** Window ffnen ***

 move.l screenpointer(pc),scr     ;Pointer auf Screen Struktur
 lea window(pc),a0                ;Struktur Window
 jsr openwindow(a6)               ;Window ffnen
 move.l d0,windowpointer          ;Pointer retten

;*** Text ausgeben ***

;Rastport fr Window
 move.l windowpointer(pc),a0
 move.l 50(a0),a0

 lea text1(pc),a1                 ;Text Struktur
 moveq #0,d0                      ;Left Offset
 moveq #0,d1                      ;Top Offset
 move.l intuitionbase(pc),a6      ;Vector Base
 jsr printitext(a6)               ;Text ber Intuition ausgeben

;*** Grafik aufbauen ***

 move.l screenpointer(pc),a0      ;Adresse Bitmap
 move.l $58(a0),a0                ;holen
 move.l $08(a0),a4


 move.l #255,d7                   ;x-Radius
 move.l #107,d6                   ;y-Radius
 move.l #320,d5                   ;x-Mittelpunkt
 move.l #128,d4                   ;y-Mittelpunkt

 move.l #26,zaehler
 clr.b modus                      ;Modus = 0
 clr.l startwinkel                ;Startwinkel = 0 Grad
 move.l #$c90fd943,endwinkel      ;Endwinkel =1.999 * PI

l1:
 move.l startwinkel(pc),d2        ;Startwinkel -> d2
 move.l endwinkel(pc),d3          ;Endwinkel ->d3
 bsr ellipse                      ;Ellipse setzen
 subi.l #10,d7
 subq.l #1,zaehler
 bne l1

 move.l #255,d7                   ;x-Radius
 move.l #27,zaehler

l2:
 move.l startwinkel(pc),d2
 move.l endwinkel(pc),d3
 bsr ellipse                      ;Ellipse setzen
 subq.l #4,d6
 subq.l #1,zaehler
 bne l2

;*** Mausclick ***

 bsr mausclick                    ;auf Mausklick warten

;*** alles schlieen ***

 move.l intuitionbase(pc),a6      ;Vector Base
 move.l windowpointer(pc),d0      ;Window Pointer
 move.l d0,a0                     ;-> a0
 beq.s abbruch1                   ;nicht geffnet -> nicht schlieen
 jsr closewindow(a6)              ;Window schlieen

abbruch1:
 move.l intuitionbase(pc),a6      ;Vector Base
 move.l screenpointer(pc),d0      ;Pointer auf Screen Struktur
 move.l d0,a0                     ;-> a0
 beq.s abbruch                    ;nicht geffnet ->
 jsr closescreen(a6)              ;Screen wieder schlieen

abbruch:
 bsr closelibs                    ;Libraries schlieen
 moveq #0,d0                      ;ok
 rts

zaehler: dc.l 0
 even

;*** Library Manager einbinden ***

 include "LibMan.asm"

;***********************************
; Datenfelder Screen + Window + Text
;***********************************

screen:       dc.w 0              ;linke Ecke
              dc.w 0              ;obere Ecke
              dc.w 640            ;Breite
              dc.w 256            ;Hhe
              dc.w 2              ;Tiefe (Farben)
              dc.b 2,3            ;Farben
              dc.w $8000          ;Modus: Hi-Res
              dc.w 15             ;Screentyp
              dc.l 0              ;kein Zeichensatz
              dc.l screentitle    ;Screentitel
              dc.l 0              ;keine Gatgets
              dc.l 0              ;keine Bitmap
screentitle:  dc.b "1991 SSC-Software/Autor: Ulf Zschuckelt",0
              even
screenpointer: dc.l 0
               even

window:       dc.w 0              ;linke Ecke
              dc.w 0              ;obere Ecke
              dc.w 640            ;Breite
              dc.w 256            ;Hhe
              dc.b 0,1            ;Farben
              dc.l $200           ;Flags fr Events
              dc.l $1006          ;Window Flags
ets
              dc.l 0              ;Zeiger auf erstes Gatget
              dc.l 0              ;Check Mark
              dc.l windowtitle    ;Windowname
scr:          dc.l 0              ;Screenpointer
              dc.l 0              ;keine Bit Map
              dc.w 640            ;min. Breite
              dc.w 256            ;min. Hhe
              dc.w 640            ;max. Breite
              dc.w 256            ;max. Hhe
              dc.w 15             ;Window-Typ
              even
windowtitle:  dc.b "Grafik",0
              even
windowpointer: dc.l 0
               even

text1:        dc.b 1,3            ;Vordergrund,Hintergrund
              dc.b 0,0            ;Zeichenmodus: JAM1, Pad
              dc.w 10,12          ;Position x,y
              dc.l 0              ;Zeichensatz: default
              dc.l zeichenkette1  ;Pointer auf String
              dc.l text2          ;Text weiter
zeichenkette1: dc.b "Grafik mit direkter Bitplanprogrammierung",0
               even

text2:        dc.b 1,3
              dc.b 0,0
              dc.w 400,240
              dc.l 0
              dc.l zeichenkette2
              dc.l 0
zeichenkette2: dc.b "Ende mit Mausclick !!!",0
               even


;
;----------------------
; ENDE HAUPTPROGRAMM
;----------------------
;

;
;----------------------
; UNTERPROGRAMME
;----------------------
;

;*** Ellipsenroutine ***

;*ebergabe :         D7: X-Radius           D6:Y-Radius
;*(alle word)         D5: X-Mittelpunkt      D4: Y-Mittelpunkt
;*                    D2: Startwinkel (FFP)  D3: Endwinkel  (FFP)
;*                    A4: Zeiger auf Bitmap
;*                    modus : 0=setzen, 1=invertieren, 255=lschen


ellipse:
 move.l d2,d0
  bsr winkel                      ;Startpunktberechnung
 move.b d2,startqua               ;Startquadrant
 move.w d0,startpunkt             ;Startpunkt
 move.l d3,d0
  bsr winkel                      ;Endpunktberechnung
 move.b d2,endqua                 ;Endquadrant
 move.w d0,endpunkt               ;Endpunkt
 move.b startqua(pc),d0
 cmpi.b #1,d0                     ;erster Quadrant ?
  bne ausschnitt                  ;Nein, nur Ausschnitt
 move.w startpunkt(pc),d0         ;Stratpunkt = 0 ?
  bne ausschnitt                  ;Nein, nur Ausschnitt
 move.b endqua(pc),d0
 cmpi.b #4,d0                     ;letzter Quadrant ?
  bne ausschnitt                  ;Nein, nur Ausschnitt
 move.w endpunkt(pc),d0
 cmpi.w #390,d0                   ;Endpunkt = 390 ?
  bne ausschnitt                  ;Nein, nur Ausschnitt


;* Ganzen Kreis oder Ellipse zeichnen (ca. 2.5 - 8 * schneller als DrawEllipse)


vollellipse:    move.w #391,d3          ;Zhler setzen
                move.w #1,d2
                lea cos-1(pc),a5        ;Zeiger auf SIN/COS- und Bit-
                lea bittab(pc),a2       ;Tabbellen
elloop:         clr.l d0
                clr.l d1
                move.b (a5,d3.w),d0     ;Tabellenwert
                mulu d7,d0              ;* x-Radius
                divu #255,d0            ;/ 255
                move.w d0,xoff          ;= x-Offset
                move.b (a5,d2.w),d1     ;Tabellenwert
                mulu d6,d1              ;* y-Radius
                divu #255,d1            ;/ 255
                move.w d1,yoff          ;= y-Offset
                add.w d5,d0             ;Mittelpunkts-
                move.w d0,xkoord        ;Koordinaten x
                cmpi.w #639,d0          ;hinzuaddieren
                bge notpunkt1           ;auf Bereichsberschreitung
                add.w d4,d1             ;prfen
                move.w d1,ykoord
                cmpi.w #255,d1
                bge notpunkt1           ;Das gleiche mit y
                bsr plot                ;Punkt 1 = xm+xoff/ym+yoff
notpunkt1:      move.w xkoord(pc),d0
                cmpi.w #639,d0
                bge notpunkt2
                move.w d4,d1            ;wie oben fr Punkt 2
                sub.w yoff,d1
                move.w d1,ykoord1
                blt notpunkt2
                bsr plot                ;Punkt 2 = xm+xoff/ym-yoff
notpunkt2:      move.w d5,d0
                sub.w xoff,d0
                move.w d0,xkoord1
                blt notpunkt3           ;wie oben fr Punkt 3
                move.w ykoord(pc),d1
                cmpi.w #255,d1
                bge notpunkt3
                bsr plot                ;Punkt 3 = xm-xoff/ym+yoff
notpunkt3:      move.w xkoord1(pc),d0
                blt notpunkt4
                move.w ykoord1(pc),d1   ;wie oben fr Punkt 4
                blt notpunkt4
                bsr plot                ;Punkt 4 = xm-xoff/ym-yoff
notpunkt4:      addq.w #1,d2
                subq.w #1,d3
                bne elloop
                rts


* Kreis- oder Ellipsenteil zeichnen

ausschnitt:     move.l #391,d0          ;Tabellen mit Tabellenwerten
                moveq.l #1,d1           ;*Radius/255 aufbauen
                clr.l d2
                lea cos-1(pc),a2
                lea austab1(pc),a5
                lea austab2(pc),a6
ausloop1:       clr.l d3
                move.b (a2,d0.w),d3
                mulu d7,d3
                divu #255,d3
                move.w d3,(a5,d2.w)
                clr.l d3
                move.b (a2,d1.w),d3
                mulu d6,d3
                divu #255,d3
                move.w d3,(a6,d2.w)
                addq.w #1,d1
                addq.w #2,d2
                subq.w #1,d0
                bne ausloop1
                lea bittab(pc),a2
                move.w endpunkt,d0      ;Wenn Endpunkt = 0 oder 1, dann
                cmpi.w #1,d0
                bhi weiter1             ;2 setzen, da sonst Fehler
                move.w #2,endpunkt
weiter1:        clr.l d0
                clr.l d1
                move.b startqua,d0
                subi.b #1,d0
                mulu #16,d0             ;(Startquadrant-1) * 16
                move.b endqua,d1        ;plus (Endquadrant-1) * 4
                subi.b #1,d1
                mulu #4,d1
                add.b d1,d0
                addi.l #sprung,d0       ;Tabellenstart
                move.l d0,a0            ;Tabellenadresse
                move.l (a0),a0          ;Startadresse auslesen
                jmp (a0)                ;und anspringen

sprung:         dc.l s1e1,s1e2,s1e3,s1e4
                dc.l s2e1,s2e2,s2e3,s2e4
                dc.l s3e1,s3e2,s3e3,s3e4
                dc.l s4e1,s4e2,s4e3,s4e4

                cnop 0,4

austab1:        ds.w 392
austab2:        ds.w 392



* Start im 1., Ende im 1. Quadranten

s1e1:           move.w startpunkt,d0
                cmp.w endpunkt,d0
                blt s1e11
                move.w #391,d1
                bsr erster
                move.w #1,d0
                bra s2e11
s1e11:          move.w endpunkt,d1
                bra erster


* Start im 1., Ende im 2. Quadranten

s1e2:           move.w startpunkt,d0
s1e22:          move.w #391,d1
                bsr erster
                move.w #1,d0
                move.w endpunkt,d1
                bra zweiter

* Start im 1., Ende im 3. Quadranten

s1e3:           move.w startpunkt,d0
s1e333:         move.w #391,d1
                bsr erster
                move.w #1,d0
s1e33:          move.w #391,d1
                bsr zweiter
                move.w #1,d0
                move.w endpunkt,d1
                bra dritter


* Start im 1., Ende im 4. Quadranten

s1e4:           move.w startpunkt,d0
s1e4444:        move.w #391,d1
                bsr erster
                move.w #1,d0
s1e44:          move.w #391,d1
                bsr zweiter
                move.w #1,d0
s1e444:         move.w #391,d1
                bsr dritter
                move.w #1,d0
                move.w endpunkt,d1
                bra vierter


* Start im 2., Ende im 1. Quadranten

s2e1:           move.w startpunkt,d0
s2e11:          move.w #391,d1
                bsr zweiter
                move.w #1,d0
s2e111          move.w #391,d1
                bsr dritter
                move.w #1,d0
s2e1111         move.w #391,d1
                bsr vierter
                move.w #1,d0
                move.w endpunkt,d1
                bra erster


* Start im 2., Ende im 2. Quadranten

s2e2            move.w startpunkt,d0
                cmp.w endpunkt,d0
                blt s2e22
                move.w #391,d1
                bsr zweiter
                move.w #1,d0
                bra s3e22
s2e22           move.w endpunkt,d1
                bra zweiter


* Start im 2., Ende im 3. Quadranten

s2e3            move.w startpunkt,d0
                bra s1e33



* Start im 2., Ende im 4. Quadranten

s2e4            move.w startpunkt,d0
                bra s1e44



* Start im 3., Ende im 1. Quadranten

s3e1            move.w startpunkt,d0
                bra s2e111



* Start im 3., Ende im 2. Quadranten

s3e2            move.w startpunkt,d0
s3e22           move.w #391,d1
                bsr dritter
                move.w #1,d0
s3e222          move.w #391,d1
                bsr vierter
                move.w #1,d0
                bra s1e22


* Start im 3., Ende im 3. Quadranten

s3e3            move.w startpunkt,d0
                cmp.w endpunkt,d0
                blt s3e33
                move.w #391,d1
                bsr dritter
                move.w #1,d0
                bra s4e33
s3e33           move.w endpunkt,d1
                bra dritter


* Start im 3., Ende im 4. Quadranten

s3e4            move.w startpunkt,d0
                bra s1e444


* Start im 4., Ende im 1. Quadranten

s4e1            move.w startpunkt,d0
                bra s2e1111


* Start im 4., Ende im 2. Quadranten

s4e2            move.w startpunkt,d0
                bra s3e222



* Start im 4., Ende im 3. Quadranten

s4e3            move.w startpunkt,d0
s4e33           move.w #391,d1
                bsr vierter
                move.w #1,d0
                bra s1e333


* Start im 4., Ende im 4. Quadranten

s4e4            move.w startpunkt,d0
                cmp.w endpunkt,d0
                blt s4e44
                move.w #391,d1
                bsr vierter
                move.w #1,d0
                bra s1e4444
s4e44           move.w endpunkt,d1
                bra vierter



* Ersten Quadranten zeichnen *

erster          move.w #391,d2          ;Zhler setzen und
                sub.w d0,d2
                move.w d2,zaehl1
                move.w #391,d2          ;invertieren
                sub.w d1,d2
                move.w d2,zaehl2
loopq1          move.w zaehl2,d2
                lsl #1,d2               ;Zhler mal 2
                move.w (a5,d2.w),d0
                add.w d5,d0
                cmpi.w #639,d0          ;x = xr + xoff
                bge noeins
                move.w (a6,d2.w),d3
                move.w d4,d1
                sub.w d3,d1             ;y = yr - yoff
                blt noeins
                bsr plot
noeins          addq.w #1,zaehl2
                move.w zaehl1,d0
                cmp.w zaehl2,d0
                bne loopq1
                rts


* Zweiten Quadranten zeichnen *

zweiter         move.w d1,zaehl1        ;Zhler setzen
                move.w d0,zaehl2
loopq2          move.w zaehl2,d2
                lsl #1,d2               ;Zhler mal 2
                move.w (a5,d2.w),d0
                add.w d5,d0
                cmpi.w #639,d0          ;x = xr + xoff
                bge nozwei
                move.w (a6,d2.w),d1
                add.w d4,d1             ;y = yr + yoff
                cmpi.w #255,d1
                bge nozwei
                bsr plot
nozwei          addq.w #1,zaehl2
                move.w zaehl1,d0
                cmp.w zaehl2,d0
                bne loopq2
                rts


* Dritten Quadranten zeichnen *

dritter         move.w #391,d2          ;Zhler setzen und
                sub.w d0,d2
                move.w d2,zaehl1
                move.w #391,d2          ;invertieren
                sub.w d1,d2
                move.w d2,zaehl2
loopq3          move.w zaehl2,d2
                lsl #1,d2               ;Zhler mal 2
                move.w (a5,d2.w),d3
                move.w d5,d0
                sub.w d3,d0             ;x = xr - xoff
                blt nodrei
                move.w (a6,d2.w),d1
                add.w d4,d1             ;y = yr + yoff
                cmpi.w #255,d1
                bge nodrei
                bsr plot
nodrei          addq.w #1,zaehl2
                move.w zaehl1,d0
                cmp.w zaehl2,d0
                bne loopq3
                rts


* Vierten Quadranten zeichnen *

vierter         move.w d1,zaehl1        ;Zhler setzen
                move.w d0,zaehl2
loopq4          move.w zaehl2,d2
                lsl #1,d2               ;Zhler mal 2
                move.w (a5,d2.w),d3
                move.w d5,d0
                sub.w d3,d0
                blt novier
                move.w (a6,d2.w),d3
                move.w d4,d1
                sub.w d3,d1             ;y = yr - yoff
                blt novier
                bsr plot
novier          addq.w #1,zaehl2
                move.w zaehl1,d0
                cmp.w zaehl2,d0
                bne loopq4
                rts


xkoord          dc.w 0
xkoord1         dc.w 0
ykoord          dc.w 0
ykoord1         dc.w 0
xoff            dc.w 0
yoff            dc.w 0
startqua        dc.b 0
                even
endqua          dc.b 0
                even
startpunkt      dc.w 0
endpunkt        dc.w 0
zaehl1          dc.w 0
zaehl2          dc.w 0
modus           dc.b 0
                even
startwinkel     dc.l 0
endwinkel       dc.l 0
                even


* Quadranten- und Punktberechnung

winkel:
 move.l mathffpbase(pc),a6        ;Vector holen
                move.l d0,a5            ;merken
                move.l #$80000043,d1    ;Ausdruck * 4
                jsr spmul(a6)
                move.l #$C90FDA43,d1    ;durch 2*PI dividieren
                jsr spdiv(a6)
                jsr spfix(a6)           ;In Integer wandeln
                move.l d0,a3            ;merken
                addi.b #1,d0            ;Plus 1
                move.b d0,d2            ;merken
                move.l a3,d0            ;Quadrant-1 ins FFP-Format
                jsr spflt(a6)           ;wandeln
                move.l #$C90FDA41,d1    ;mit PI/2 multiplizieren
                jsr spmul(a6)
                move.l d0,d1            ;von Winkel abziehen
                move.l a5,d0
                jsr spsub(a6)
                move.l #$C3800049,d1    ;mit 391 multiplizieren
                jsr spmul(a6)
                move.l #$C90FDA41,d1    ;durch PI/2 dividieren
                jsr spdiv(a6)
                jsr spfix(a6)           ;in Integer wandeln
                rts


* Tabelle mit Cosinus- (vorwrts) und Sinus- (rckwrts) Werten


cos     dc.b 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19
        dc.b 20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35
        dc.b 36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51
        dc.b 52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67
        dc.b 68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83
        dc.b 84,85,86,87,88,89,90,91,92,93,94,94,95,96,97,98
        dc.b 99,100,101,102,103,104,105,106,107,108,109,109,110
        dc.b 111,112,113,114,115,116,117,118,119,120,120,121
        dc.b 122,123,124,125,126,127,128,128,129,130,131,132
        dc.b 133,134,135,135,136,137,138,139,140,141,141,142
        dc.b 143,144,145,146,147,147,148,149,150,151,152,152
        dc.b 153,154,155,156,156,157,158,159,160,160,161,162
        dc.b 163,164,164,165,166,167,167,168,169,170,171,171
        dc.b 172,173,174,174,175,176,177,177,178,179,179,180
        dc.b 181,182,182,183,184,184,185,186,187,187,188,189
        dc.b 189,190,191,191,192,193,193,194,195,195,196,197
        dc.b 197,198,199,199,200,200,201,202,202,203,204,204
        dc.b 205,205,206,207,207,208,208,209,210,210,211,211
        dc.b 212,212,213,214,214,215,215,216,216,217,217,218
        dc.b 218,219,219,220,221,221,222,222,223,223,224,224
        dc.b 224,225,225,226,226,227,227,228,228,229,229,230
        dc.b 230,230,231,231,232,232,233,233,233,234,234,235
        dc.b 235,235,236,236,237,237,237,238,238,238,239,239
        dc.b 239,240,240,240,241,241,241,242,242,242,243,243
        dc.b 243,244,244,244,244,245,245,245,246,246,246,246
        dc.b 247,247,247,247,248,248,248,248,249,249,249,249
        dc.b 249,250,250,250,250,250,251,251,251,251,251,251
        dc.b 252,252,252,252,252,252,252,253,253,253,253,253
        dc.b 253,253,253,253,254,254,254,254,254,254,254,254
        dc.b 254,254,254,254,254,254,254,254,254,254,254,254
        dc.b 254,254
        even

* Punt setzen/lschen/invertiern

plot    and.l #$FFFF,d0         ;INT(X/8)*8 = Byte in Zeile
        move.w d0,a1
        divu #8,d0
        and.l #$FF,d1           ;y*80 = Zeilenoffset
        mulu #80,d1
        add.l a4,d1             ;Start Bitmap
        add.w d0,d1
        move.l a1,d0
        move.b (a2,d0.w),d0     ;Bit holen
        move.l d1,a1
        move.b (a1),d1          ;Grafikbyte holen
        tst.b modus             ;Modus holen
        beq setz                ;Punkt setzen
        bmi lsch               ;Punkt lschen

* Punkt invertieren

        eor.b d0,d1             ;Bit invertieren
        move.b d1,(a1)          ;Byte setzen
        rts

* Punkt setzen

setz    or.b d0,d1              ;Bit setzen
        move.b d1,(a1)          ;Byte setzen
        rts

* Punkt lschen

lsch   eor.b #$FF,d0           ;Byte umdrehen
        and.b d0,d1             ;Bit lschen
        move.b d1,(a1)          ;Byte setzen
        rts


* Bits der x-Koordinaten

bittab          dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                dc.b 128,64,32,16,8,4,2,1,128,64,32,16,8,4,2,1
                even

;*** Mausclick ***

mausclick:
 btst #6,$bfe001                  ;6.Bit von $bfe001 = Mausclick
 bne.s mausclick                  ;wenn Bit =0 dann ->
 rts

 end                              ;ENDE DES PROGRAMMS

